SystemOrganization addCategory: #CommonTraits!
SystemOrganization addCategory: #'CommonTraits-Announcement'!
SystemOrganization addCategory: #'CommonTraits-Compare'!
SystemOrganization addCategory: #'CommonTraits-Compare-Test'!

Trait named: #TAnnouncer
	uses: {}
	category: 'CommonTraits-Announcement'!

!TAnnouncer commentStamp: 'SantiagoBragagnolo 11/12/2012 10:32' prior: 0!
Just a delagate to get the tipical behavior that should show an object which let you know announcements . (Instead of getting it behavior from an inheritance)!

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
announce: anAnnouncement 
	self resolveAnnouncer announce:anAnnouncement.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
announcer
	self required.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
announcer: anAnnouncer
	self required.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
removeSubscription: subscription
	^self resolveAnnouncer removeSubscription: subscription.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:33'!
resolveAnnouncer
	| announcer | 
	self announcer ifNil: [
		self announcer: Announcer new.	
	].
	^ self announcer! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:34'!
subscribe: aAnnouncement do: aBlock
	^self resolveAnnouncer subscribe: aAnnouncement do: aBlock! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:34'!
subscribe: anAnnouncementClass send: aSelector to: anObject
	^self resolveAnnouncer subscribe: anAnnouncementClass send: aSelector to: anObject.! !

!TAnnouncer methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 11/12/2012 10:34'!
unsubscribe: anObject
	^self resolveAnnouncer unsubscribe: anObject.! !

Trait named: #TEquality
	uses: {}
	category: 'CommonTraits-Compare'!

!TEquality commentStamp: '<historical>' prior: 0!
TEquality is a trait that provides a generic implementation for = and hash.
It aims avoiding to implement = and hash for simple cases.
To make instances of some class comparable, simply make the class use this trait.

TEquality relies on message valuesToCompareForEquality sent to objects for both = and hash.
The default implmentation of this message is provided by Object.
Override ONLY valuesToCompareForEquality method for custom equality check.!

!TEquality methodsFor: 'comparing' stamp: 'NouryBouraqadi 2/4/2011 23:59'!
= anObject 
	self species = anObject species ifFalse: [^false].
	^self valuesToCompareForEquality = anObject valuesToCompareForEquality! !

!TEquality methodsFor: 'comparing' stamp: 'NouryBouraqadi 2/4/2011 18:10'!
hash
	^self valuesToCompareForEquality inject: self species hash into: [:hash :comparisonValue|
		(hash + comparisonValue hash) hashMultiply]
! !

TestCase subclass: #EqualityTest
	instanceVariableNames: 'classFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CommonTraits-Compare-Test'!

!EqualityTest methodsFor: 'setUp-tearDown' stamp: 'NouryBouraqadi 2/4/2011 19:40'!
setUp
	super setUp.
	classFactory := ClassFactoryForTestCase new.
! !

!EqualityTest methodsFor: 'setUp-tearDown' stamp: 'NouryBouraqadi 2/4/2011 19:41'!
tearDown
	super tearDown.
	classFactory cleanUp
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsOnlyOneInstanceOfAClassWithIVs
	| set object class |
	class  := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	class compile: 'x: newX y: newY
		x := newX.
		y := newY'.
	class class compile: 'x: newX y: newY
		^self new
			x: newX y: newY;
			yourself'.
	set := Set new.
	10 timesRepeat: [
		object  := class x: 1 y: 2.
		set add: object].
	self assert: set size = 1.
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsOnlyOneInstanceOfAClassWithNoIVs
	| set |
	set := Set new.
	10 timesRepeat: [set add: ComparableObjectForEqualityTest new].
	self assert: set size = 1.
	self assert: (set includes: ComparableObjectForEqualityTest new)
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsTwoInstancesOfTwoDiffrentClassesWithIVs
	| set otherClass yetAnotherClass |
	otherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	yetAnotherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	{otherClass. yetAnotherClass} do: [:class|
		class compile: 'x: newX y: newY
			x := newX.
			y := newY'.
		class class compile: 'x: newX y: newY
			^self new
				x: newX y: newY;
				yourself'.
	].
	set := Set with: (otherClass x: 'abc' y: 123) with: (yetAnotherClass x: 'abc' y: 123).
	self assert: set size = 2.
	self assert: (set includes: (otherClass x: 'abc' y: 123)).
	self assert: (set includes: (yetAnotherClass x: 'abc' y: 123)).
! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testSetContainsTwoInstancesOfTwoDiffrentClassesWithNoIVs
	| set otherClass |
	otherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: '' classVariableNames:  ''.
	set := Set with: ComparableObjectForEqualityTest new with: otherClass new.
	self assert: set size = 2.
	self assert: (set includes: ComparableObjectForEqualityTest new).
	self assert: (set includes: otherClass new).

! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTheSameClassWithDifferentIvValuessAreNOTEqual
	| class |
	class  := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	class compile: 'x: newX y: newY
		x := newX.
		y := newY'.
	class class compile: 'x: newX y: newY
		^self new
			x: newX y: newY;
			yourself'.
	self deny: (class x: 1 y: 'abc') = (class x: 1 y: 'zyx').! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTheSameClassWithNoIVsAreEqual
	self assert: ComparableObjectForEqualityTest new = ComparableObjectForEqualityTest new
	! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTheSameClassWithSameIvValuessAreEqual
	| class |
	class  := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: 'x y' classVariableNames:  ''.
	class compile: 'x: newX y: newY
		x := newX.
		y := newY'.
	class class compile: 'x: newX y: newY
		^self new
			x: newX y: newY;
			yourself'.
	self assert: (class x: 1 y: 'abc') = (class x: 1 y: 'abc').! !

!EqualityTest methodsFor: 'testing' stamp: 'NouryBouraqadi 2/5/2011 09:32'!
testTwoInstancesOfTowDifferentClassesWithNoIVsAreNOTEqual
	| otherClass |
	otherClass := classFactory newSubclassOf: ComparableObjectForEqualityTest  instanceVariableNames: '' classVariableNames:  ''.
	self deny: otherClass new = ComparableObjectForEqualityTest new! !

Object subclass: #ComparableObjectForEqualityTest
	uses: TEquality
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CommonTraits-Compare-Test'!

ComparableObjectForEqualityTest class
	uses: TEquality classTrait
	instanceVariableNames: ''!
